/* Yvonne 1.0
 * by Rafal BOBER Ciepiela
 * contact: bob_er@users.sourceforge.net
 * 2006
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "g09.h"

using namespace std;

////////////////////////////////////////////////////////

CG09::CG09(CColorProvider* _pColors):CImage(_pColors)
{
	m_cPicture1=NULL;
	m_cPicture2=NULL;
	return;
}

////////////////////////////////////////////////////////

CG09::~CG09(void)
{
	if(m_cPicture1!=NULL)
		delete m_cPicture1;
	if(m_cPicture2!=NULL)
		delete m_cPicture2;
	return;
}

////////////////////////////////////////////////////////

bool CG09::open(char* _szPath)
{
	if(_szPath==NULL)
		throw CImageException(CImageException::IE_BAD_PARAMS);
	m_sFileName=_szPath;
	m_fInFile.open(_szPath, ios::in);
	if(m_fInFile.is_open()==false)
		throw CImageException(CImageException::IE_CANNOT_OPEN_FILE);
	m_cPicture1=new unsigned char[IMAGE_SIZE_FULLSCREEN];
	m_cPicture2=new unsigned char[IMAGE_SIZE_FULLSCREEN];
	m_fInFile.read(reinterpret_cast<char *>(m_cPicture1), IMAGE_SIZE_FULLSCREEN);
	m_fInFile.read(reinterpret_cast<char *>(m_cPicture2), IMAGE_SIZE_FULLSCREEN);
	if(m_fInFile.eof()==true)
		throw CImageException(CImageException::IE_CANNOT_READ_FILE);
	m_fInFile.close();
	m_nWidth=640;
	m_nHeight=192;
	return true;
}

////////////////////////////////////////////////////////

unsigned int CG09::getPixel(unsigned int _nX, unsigned int _nY)
{
	unsigned char* cPicture;
	unsigned int nX;
	unsigned int nSeek;
	unsigned int nResult;

	if((_nX>=m_nWidth) || (_nY>=m_nHeight))
		throw CImageException(CImageException::IE_BAD_PARAMS);
	if(_nX<320)
	{
		cPicture=m_cPicture1;
		nX=_nX;
	}
	else
	{
		cPicture=m_cPicture2;
		nX=_nX-320;
	}
	nX=nX>>2;
	nSeek=(40*_nY)+(nX>>1);
	nResult=cPicture[nSeek];
	switch(nX&0x01)
	{
	case 0:
		nResult=(nResult&0xf0)>>4;
		break;
	case 1:
		nResult=nResult&0x0f;
		break;
	default:
		throw CImageException(CImageException::IE_BAD_PARAMS);
	}
	nResult=m_pColorProvider->getColor(nResult);
	return nResult;
}

////////////////////////////////////////////////////////

const char* CG09::getFileName(void)
{
	return m_sFileName.c_str();
}

////////////////////////////////////////////////////////

const char* CG09::getFileSize(void)
{
	return "160x192(wide); 16 colours";
}

////////////////////////////////////////////////////////

const char* CG09::getFileProperties(void)
{
	return "No properties supported.";
}

////////////////////////////////////////////////////////
