/* Yvonne 1.0
 * by Rafal BOBER Ciepiela
 * contact: bob_er@users.sourceforge.net
 * 2006
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "gr9.h"

using namespace std;

////////////////////////////////////////////////////////

CGr9::CGr9(CColorProvider* _pColors):CImage(_pColors)
{
	m_cPicture=NULL;
	return;
}

////////////////////////////////////////////////////////

CGr9::~CGr9(void)
{
	if(m_cPicture!=NULL)
		delete m_cPicture;
	return;
}

////////////////////////////////////////////////////////

bool CGr9::open(char* _szPath)
{
	if(_szPath==NULL)
		throw CImageException(CImageException::IE_BAD_PARAMS);
	m_sFileName=_szPath;
	m_fInFile.open(_szPath, ios::in);
	if(m_fInFile.is_open()==false)
		throw CImageException(CImageException::IE_CANNOT_OPEN_FILE);
	m_cPicture=new unsigned char[IMAGE_SIZE_FULLSCREEN];
	m_fInFile.read(reinterpret_cast<char *>(m_cPicture), IMAGE_SIZE_FULLSCREEN);
	if(m_fInFile.eof()==true)
		throw CImageException(CImageException::IE_CANNOT_READ_FILE);
	m_fInFile.close();
	m_nWidth=320;
	m_nHeight=192;
	return true;
}

////////////////////////////////////////////////////////

unsigned int CGr9::getPixel(unsigned int _nX, unsigned int _nY)
{
	unsigned int nX;
	unsigned int nSeek;
	unsigned int nResult;

	if((_nX>=m_nWidth) || (_nY>=m_nHeight))
		throw CImageException(CImageException::IE_BAD_PARAMS);
	nX=_nX>>2;
	nSeek=(40*_nY)+(nX>>1);
	nResult=m_cPicture[nSeek];
	switch(nX&0x01)
	{
	case 0:
		nResult=(nResult&0xf0)>>4;
		break;
	case 1:
		nResult=nResult&0x0f;
		break;
	default:
		throw CImageException(CImageException::IE_BAD_PARAMS);
	}
	nResult=m_pColorProvider->getColor(nResult);
	return nResult;
}

////////////////////////////////////////////////////////

const char* CGr9::getFileName(void)
{
	return m_sFileName.c_str();
}

////////////////////////////////////////////////////////

const char* CGr9::getFileSize(void)
{
	return "80x192; 16 colours";
}

////////////////////////////////////////////////////////

const char* CGr9::getFileProperties(void)
{
	return "No properties supported.";
}

////////////////////////////////////////////////////////
