/* Yvonne 1.0
 * by Rafal BOBER Ciepiela
 * contact: bob_er@users.sourceforge.net
 * 2006
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <QtGui/QApplication>

#include "widget.h"

using namespace std;

int main(int argc, char* argv[])
{
	QApplication app(argc, argv);
	QMainWindow* pWindow;
	CWidget* pWidget;
	int nResult=1;
	
	try
	{
		pWindow=new QMainWindow();
		pWidget=new CWidget(pWindow);
		if(argc==2)
			pWidget->init(argv[1]);
		else
			pWidget->init();
		pWindow->show();
		nResult=app.exec();
	}
	catch(CCPException &e)
	{
		QMessageBox::critical(NULL, NAME, e.what());
	}
	catch(CRCFileException &e)
	{
		QMessageBox::critical(NULL, NAME, e.what());
	}
	catch(...)
	{
		QMessageBox::critical(NULL, NAME, "Unknown exception.");
	}
	return nResult;
}
